//+------------------------------------------------------------------+
//|                                                  VisualTrend.mq4 |
//|                                                   Stewart Mcnabb |
//|                                          |
//+------------------------------------------------------------------+
#property copyright "Stewart McNabb"


#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 5
#property indicator_buffers 8
#property indicator_color1 Green
#property indicator_color2 Red
#property indicator_color3 Green
#property indicator_color4 Red
#property indicator_color5 Green
#property indicator_color6 Red
#property indicator_color7 Green
#property indicator_color8 Red

//---- buffers
double D_Up_Buffer[];
double D_Down_Buffer[];
double FH_Up_Buffer[];
double FH_Down_Buffer[];
double H_Up_Buffer[];
double H_Down_Buffer[];
double T_Up_Buffer[];
double T_Down_Buffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,159);
   SetIndexBuffer(0,H_Up_Buffer);
   SetIndexEmptyValue(0,0.0);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,159);
   SetIndexBuffer(1,H_Down_Buffer);
   SetIndexEmptyValue(1,0.0);
   SetIndexStyle(2,DRAW_ARROW);
   SetIndexArrow(2,159);
   SetIndexBuffer(2,FH_Up_Buffer);
   SetIndexEmptyValue(2,0.0);
   SetIndexStyle(3,DRAW_ARROW);
   SetIndexArrow(3,159);
   SetIndexBuffer(3,FH_Down_Buffer);
   SetIndexEmptyValue(3,0.0);
   SetIndexStyle(4,DRAW_ARROW);
   SetIndexArrow(4,159);
   SetIndexBuffer(4,D_Up_Buffer);
   SetIndexEmptyValue(4,0.0);
   SetIndexStyle(5,DRAW_ARROW);
   SetIndexArrow(5,159);
   SetIndexBuffer(5,D_Down_Buffer);
   SetIndexEmptyValue(5,0.0);
   SetIndexStyle(6,DRAW_ARROW);
   SetIndexArrow(6,159);
   SetIndexBuffer(6,T_Up_Buffer);
   SetIndexEmptyValue(6,0.0);
   SetIndexStyle(7,DRAW_ARROW);
   SetIndexArrow(7,159);
   SetIndexBuffer(7,T_Down_Buffer);
   SetIndexEmptyValue(7,0.0);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
//---- TODO: add your code here
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- 
   double d_macd_current=iMACD(NULL,PERIOD_H4,12,26,9,PRICE_CLOSE,MODE_MAIN,0);
   double d_signal_current=iMACD(NULL,PERIOD_H4,12,26,9,PRICE_CLOSE,MODE_SIGNAL,0);
   double fh_macd_current=iMACD(NULL,PERIOD_H4,12,26,9,PRICE_CLOSE,MODE_MAIN,0);
   double fh_macd_previous=iMACD(NULL,PERIOD_H4,12,26,9,PRICE_CLOSE,MODE_MAIN,1);
   double h_macd_current=iMACD(NULL,PERIOD_D1,12,26,9,PRICE_CLOSE,MODE_MAIN,0);
   double h_signal_current=iMACD(NULL,PERIOD_D1,12,26,9,PRICE_CLOSE,MODE_SIGNAL,0);
   double t_macd_current=iMACD(NULL,PERIOD_D1,12,26,9,PRICE_CLOSE,MODE_MAIN,0);
   double t_macd_previous=iMACD(NULL,PERIOD_D1,12,26,9,PRICE_CLOSE,MODE_MAIN,1);
   
   if(d_macd_current > d_signal_current)
   {
      D_Up_Buffer[0] = 4.0;
      D_Down_Buffer[0] = 0.0;      
   }
   if(d_macd_current < d_signal_current)
   {
      D_Up_Buffer[0] = 0.0;
      D_Down_Buffer[0] = 4.0;      
   }
   
   if(fh_macd_current > fh_macd_previous)
   {
      FH_Up_Buffer[0] = 3.0;
      FH_Down_Buffer[0] = 0.0;      
   }
   if(fh_macd_current < fh_macd_previous)
   {
      FH_Up_Buffer[0] = 0.0;
      FH_Down_Buffer[0] = 3.0;      
   }
   
   if(h_macd_current > h_signal_current)
   {
      H_Up_Buffer[0] = 2.0;
      H_Down_Buffer[0] = 0.0;      
   }
   if(h_macd_current < h_signal_current)
   {
      H_Up_Buffer[0] = 0.0;
      H_Down_Buffer[0] = 2.0;      
   }
   
   if(t_macd_current > t_macd_previous)
   {
      T_Up_Buffer[0] = 1.0;
      T_Down_Buffer[0] = 0.0;      
   }
   if(t_macd_current < t_macd_previous)
   {
      T_Up_Buffer[0] = 0.0;
      T_Down_Buffer[0] = 1.0;      
   }
 
//----
   return(0);
  }
//+------------------------------------------------------------------+